#ifndef QELANTOUCHPAD_H_
#define QELANTOUCHPAD_H_
#include <QTextFormat>
#include <QDialog>
#include <QSystemTrayIcon>
#include <QMenu>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <fcntl.h>
#include <iostream>
#include <unistd.h>

#include "debug_elan.h"
#include "elantech.h"
#include "ui_Elantech_Smart_pad.h"

#define ELAN_VERSION "ETD7.1.4 Free"
#define QtElanTrayIcon 1
#define QtElantechtMultiLanguage 0
using namespace std;
typedef struct {

	/*page General*/
	int	SHM_touch_checkBox;
	double	SHM_maxspeed_slider; 

	/*page Button*/
	int	SHM_button_checkBox;
	int	SHM_button_left_comboBox;
	int	SHM_button_middle_comboBox;
	int	SHM_button_right_comboBox;
	
	/*page Tapping*/
	int	SHM_tapping_checkBox;
	int	SHM_two_FT_comboBox;
	int	SHM_three_FT_comboBox;
	int	SHM_disable_when_key_checkBox;
	int	SHM_tapping_delay_comboBox;
	int	SHM_cursor_delay_comboBox;
	int	SHM_cover_delay_comboBox;
	int	SHM_gesture_delay_comboBox;
	int	SHM_palm_delay_comboBox;

	/*page Scrolling*/
	int	SHM_vertical_scrolling_checkBox;
	int	SHM_horizontal_scrolling_checkBox;
	int	SHM_scrolling_speed_slider;	
	int	SHM_auto_scroll_checkBox;

	/*edge Scrolling*/
	int	SHM_edge_v_scroll_checkBox;
	int	SHM_edge_h_scroll_checkBox;
	int	SHM_edge_scroll_speed_slider;
	int	SHM_edge_scroll_area_slider;

	/*page Zoom*/
	int	SHM_zoom_checkBox;
	int	SHM_zoom_out_comboBox;
	int	SHM_zoom_in_comboBox;
	int 	SHM_zoom_slider;

	/*page Rotation*/
	int	SHM_rotation_checkBox;
	int 	SHM_clockwise_comboBox;
	int	SHM_counterclosewise_comboBox;
	int	SHM_rotation_slider;
	
	/*page Drag*/
	int	SHM_drag_checkBox;
	int	SHM_lift_release_radioButton;
	int	SHM_tap_again_radioButton;
	int	SHM_tap_release_radioButton;
	double  SHM_drag_slider;
	
	/*page Swipe*/
	int	SHM_swipe_page_checkBox;
	
	/*page Fast_keys*/
	int	SHM_fast_key_checkBox;
	int	SHM_my_home_file_checkBox;
	int	SHM_switch_windows_checkBox;

	/*page Covergesture*/
	int	SHM_covergesture_checkBox;
	int	SHM_covergesture_slider;
	int	SHM_covergesture_comboBox;

	/*page PalmTracking*/
	int	SHM_palmtracking_checkBox;
	int	SHM_palmtracking_slider;

	
} Elashm;


class QElantouchPad : public QDialog, public Ui::Form
{
	Q_OBJECT


protected slots:
	/*page General*/
	void	slot_touchpadoff_checkBox();
	void	slot_maxspeed_slider();
	
	/*page Button*/
	void	slot_button_checkBox();
	void	slot_button_left_comboBox(int index);
	void	slot_button_middle_comboBox(int index);
	void	slot_button_right_comboBox(int index);
	
	/*page Tapping*/
	void	slot_tapping_checkBox();
	void	slot_two_FT_comboBox(int index);
	void	slot_three_FT_comboBox(int index);
	void	slot_disable_when_key_checkBox();
	void 	slot_tapping_delay_comboBox(int index);
	void 	slot_cursor_delay_comboBox(int index);
	void	slot_cover_delay_comboBox(int index);
	void	slot_gesture_delay_comboBox(int index);
	void	slot_palm_delay_comboBox(int index);

	/*page Scrolling*/
	void	slot_vertical_scrolling_checkBox();
	void	slot_horizontal_scrolling_checkBox();
	void	slot_scrolling_speed_slider();
	void	slot_auto_scroll_checkBox();

	/*page Edge Scrolling*/
	void	slot_edge_v_scroll_checkBox();
	void	slot_edge_h_scroll_checkBox();
	void	slot_edge_scroll_speed_slider();
	void	slot_edge_scroll_area_slider();

	/*page Zoom*/
	void	slot_zoom_checkBox();
	void	slot_zoom_out_comboBox(int index);
	void	slot_zoom_in_comboBox(int index);
	void 	slot_zoom_slider();
	
	/*page Rotation*/
	void	slot_rotation_checkBox();
	void 	slot_clockwise_comboBox(int index);
	void	slot_counterclosewise_comboBox(int index);
	void	slot_rotation_slider();
	
	/*page Drag*/
	void	slot_drag_checkBox();
	void	slot_lift_release_radioButton();
	void	slot_tap_again_radioButton();
	void	slot_tap_release_radioButton();
	void	slot_drag_slider();

	/*page Swipe*/
	void	slot_swipe_page_checkBox();
	
	/*page Fast_keys*/
	void	slot_fast_key_checkBox();
	void	slot_my_home_file_checkBox();
	void	slot_switch_windows_checkBox();

	/*page Covergesture*/
	void	slot_covergesture_checkBox();
	void	slot_covergesture_slider();
	void	slot_covergesture_comboBox(int index);

	/*page PalmTracking*/
	void	slot_palmtracking_checkBox();
	void	slot_palmtracking_slider();

	/*Push button*/
	void 	slot_default_pushbutton();
	void	slot_yes_pushbutton();
        void	slot_cancel_pushbutton();
	void 	slot_apply_pushbutton();

	/*Tray Icon*/
#if QtElanTrayIcon
	void	slot_iconActivated(QSystemTrayIcon::ActivationReason reason);//TOM +
	void	slot_iconPopMenu();
#endif

private:
	void define_elanshm_value();	
	void cur_elanshm_value();
	void catch_elanshm_value();
	void set_elanshm_value();
	Elashm cur_elanshm,apply_elanshm;
	
#if QtElanTrayIcon
	QSystemTrayIcon	*trayIcon;
	void createTrayIconActions();
	void createTrayIcon();
	//QAction *minimizeAction;
	QAction *restoreAction;
	//QAction *quitAction;
	QMenu	*trayIconMenu;
#endif
	void seltct_touchpad_style();
# if QtElantechtMultiLanguage
	void select_multi_language();
	void change_help_file_TW();
	void change_help_file_US();
	void change_help_file_CN();
	void change_help_file_JP();
	void change_help_file_KR();
	void change_help_file_FR();
	void change_help_file_DE();
	void change_help_file_IT();
	void change_help_file_NL();
	void change_help_file_ES();
	void change_help_file_PT();
	void change_help_file_RU();
	void change_help_file_TH();
	void change_help_file_SE();
	void change_help_file_BR();
	void change_help_file_ARA();
//-------------------------------------
	void change_help_file_CZ();
	void change_help_file_Danish();
	void change_help_file_Finnish();
	void change_help_file_Greek();
	void change_help_file_HE();
	void change_help_file_Hungarian();
	void change_help_file_NO();
	void change_help_file_PL();
	void change_help_file_Slovak();
	void change_help_file_Turkish();
#endif
public:
	QElantouchPad (QWidget *parent = NULL);
};


#endif	
