/*   Elantech Passthrough Support
 *   Copyright (c) 2008 Elantech Inc Tom Lin<tom_lin@elantech.com.tw>
 *   
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * Trademarks are the property of their respective owners.
 *
 */
 #ifndef _ELAPROTO_H_
 #define _ELAPROTO_H_
 
 #include <unistd.h>
 #include <sys/ioctl.h>
 #include <xf86Xinput.h>
 #include <xisb.h>
 
/*
 * A structure to describe the state of the touchpad hardware (buttons and pad)
 */
 struct ElantechHwState {
    int millis;			/* Timestamp in milliseconds */
    int x;			/* X position of finger */
    int y;			/* Y position of finger */
    int z;			/* Finger pressure */
    int w;
    int x2_1,y2_1;
    int x2_2,y2_2;
    int x3_1,y3_1;
    int numFingers;
    
    Bool left;
    Bool right;
    Bool up;
    Bool down;
    Bool middle;
    
    Bool MKY;
    Bool VF;
};

struct CommData {
    XISBuffer	    *buffer;
    unsigned char   protoBuf[6];
    unsigned char   lastByte;
    int outOfSync;
    
    int protoBufTail;
    
    struct ElantechHwState hwState;
    Bool oneFinger;
    Bool twoFingers;
    Bool threeFingers;
};

struct _ElantechSHM;

struct CommData;

struct ElantechProtocolOperations {
	void (*DeviceOnHook)(LocalDevicePtr local,struct _ElantechSHM *para);
	void (*DeviceOffHook)(LocalDevicePtr local);
	Bool (*QueryHardware)(LocalDevicePtr local);
	Bool (*ReadHwState)(LocalDevicePtr local,
			    struct ElantechProtocolOperations *proto_ops,
			    struct CommData *comm, struct ElantechHwState *hwRet);
	Bool (*AutoDevProbe)(LocalDevicePtr local);
	void (*ReadDevDimensions)(LocalDevicePtr local);
};

extern struct ElantechProtocolOperations event_proto_operations;

 
#endif 