#include "elan_linux_main.h"

#define change_cursor_image 0
#define Linpus_driver	0


#define CMD_STRING_MAXLEN 256
#define MAX_KEYSYM 65536
#define NUM_KEY_MODIFIERS 3
#define COUNT_ZOOM_MAX 2
#define WAIT_TIME 950
#define debug_fire_fox 0

#define BITMAP_HOT_DEFAULT 8
#define Dynamic 1

#define DESKTOP		"x-nautilus-desktop"
#define PHOTO_STR	"Gwenview"
#define PHOTO_STR1	"F-Spot"
#define FIRE_FOX 	"Mozilla"
#define ACROBAT  	"Adobe Reader"
#define Open_Office	"OpenOffice"
#define ELAN_TOUCHPAD	"Smart-Pad"
#if Linpus_driver
#define WEB_BROWSER	"- Minefield"
#else
#define WEB_BROWSER	"Web Browser"
#endif
#define File_Manager 	" - File Manager" /*for linpus*/
#define PHOTO_JPG	".JPG"
#define PHOTO_jpg	".jpg"
#define PHOTO_BMP	".BMP"
#define PHOTO_bmp	".bmp"
#define PHOTO_PNG	".PNG"
#define PHOTO_png	".png"
#define PHOTO_ICO	".ICO"
#define PHOTO_ico	".ico"
#define PHOTO_GIF	".GIF"
#define PHOTO_gif	".gif"
#define PHOTO_XBM	".XBM"
#define PHOTO_xbm	".xbm"


static int Button_Left_down,Button_Middle_down,Button_Right_down;
int keysym_to_modifier_map[ MAX_KEYSYM ];
KeyCode keysym_to_keycode_map[ MAX_KEYSYM ];
char *key_modifiers[] = { NULL, "Shift_L", "ISO_Level3_Shift" };

const char *Escape="Escape";
const char *CONTROL_L="Control_L"; 
const char *ALT_L="Alt_L";
const char *SHIFT_L="Shift_L";
const char *RIGHT="Right";
const char *LEFT="Left";
#if Linpus_driver
const char *F10="F5";
const char *F9="F8";
#else
const char *F10="F10";
const char *F9="F9";
#endif
const char *F4="F4";
const char *PAGE_DOWN="Page_Down";
const char *PAGE_UP="Page_Up";
const char *TAB="Tab";
char string;
char *Rotation_right_image = "/usr/share/elantouchpad_data/cursor_image/Right_Rotate.xbm";
char *Rotation_left_image = "/usr/share/elantouchpad_data/cursor_image/Left_Rotate.xbm";
char *Zoom_in_image = "/usr/share/elantouchpad_data/cursor_image/Zoom_In.xbm";
char *Zoom_out_image = "/usr/share/elantouchpad_data/cursor_image/Zoom_Out.xbm";
char *Scrool_V_image = "/usr/share/elantouchpad_data/cursor_image/V_Scroll.xbm";
char *Scrool_H_image = "/usr/share/elantouchpad_data/cursor_image/H_Scroll.xbm";


int for_xorg_finger_flog;

#if change_cursor_image

int screen;
Window root;
int save_colors = 0;

static XColor 
NameToXColor(Display *dpy,char *name, unsigned long pixel)
{
    XColor c;
    
    if (!name || !*name) {
	c.pixel = pixel;
	XQueryColor(dpy, DefaultColormap(dpy, screen), &c);
    } else if (!XParseColor(dpy, DefaultColormap(dpy, screen), name, &c)) {
	fprintf(stderr, "unknown color or bad color format\n");
	/*NOTREACHED*/
    }
    return(c);
}

static Pixmap 
ReadBitmapFile(Display *dpy,char *filename, unsigned int *width, unsigned int *height, 
	       int *x_hot, int *y_hot)
{
    Pixmap bitmap;
    int status;

    status = XReadBitmapFile(dpy, root, filename, width,
			     height, &bitmap, x_hot, y_hot);
    if (status == BitmapSuccess)
      return(bitmap);
    else if (status == BitmapOpenFailed)
	fprintf(stderr, "can't open file: %s\n");
    else if (status == BitmapFileInvalid)
	fprintf(stderr, "bad bitmap format file\n");
    else
	fprintf(stderr, "insufficient memory for bitmap:");
    return 0;
    /*NOTREACHED*/
}


static Cursor
CreateCursorFromFiles(Display *d,char *cursor_file, char *mask_file)
{
    Pixmap cursor_bitmap, mask_bitmap;
    unsigned int width, height, ww, hh;
    int x_hot, y_hot;
    char *fore_color = NULL;
    char *back_color = NULL;
    Cursor cursor;
    XColor fg, bg, temp;

    fg = NameToXColor(d,fore_color, BlackPixel(d, screen));
    error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/Right_Rotate.xbm /usr/share/elantouchpad_data/cursor_image/Right_Rotate.xbm");
    bg = NameToXColor(d,back_color, WhitePixel(d, screen));
   /* if (reverse) {
	temp = fg; fg = bg; bg = temp;
    }*/

    cursor_bitmap = ReadBitmapFile(d,cursor_file, &width, &height, &x_hot, &y_hot);
    mask_bitmap = ReadBitmapFile(d,mask_file, &ww, &hh, (int *)NULL, (int *)NULL);

    if (width != ww || height != hh) {
	fprintf(stderr,"dimensions of cursor bitmap and cursor mask bitmap are different\n");
	//exit(1);
	/*NOTREACHED*/
    }

    if ((x_hot == -1) && (y_hot == -1)) {
	x_hot = BITMAP_HOT_DEFAULT;
	y_hot = BITMAP_HOT_DEFAULT;
    }
    if ((x_hot < 0) || (x_hot >= width) ||
	(y_hot < 0) || (y_hot >= height)) {
	fprintf(stderr, "hotspot is outside cursor bounds\n");
	//exit(1);
	/*NOTREACHED*/
    }

    cursor = XCreatePixmapCursor(d, cursor_bitmap, mask_bitmap, &fg, &bg,
				 (unsigned int)x_hot, (unsigned int)y_hot);
    XFreePixmap(d, cursor_bitmap);
    XFreePixmap(d, mask_bitmap);

    return(cursor);
}

#endif

void load_keycodes( Display *d ) {
  int min_keycode,max_keycode,keysyms_per_keycode,keycode_index,wrap_key_index,num_modifiers;
  char *str;
  KeySym *keysyms, keysym;
  KeyCode keycode;

  XDisplayKeycodes( d, &min_keycode, &max_keycode);
  keysyms = XGetKeyboardMapping( d,
    (KeyCode)min_keycode, max_keycode + 1 - min_keycode,
    &keysyms_per_keycode );

  /* Clear tables */
  for( keysym=0; keysym<MAX_KEYSYM; keysym++ ) {
    keysym_to_modifier_map[keysym]=-1;
    keysym_to_keycode_map[keysym]=0;
  }

  if( keysyms_per_keycode < NUM_KEY_MODIFIERS ) {
    num_modifiers = keysyms_per_keycode;
  } else {
    num_modifiers = NUM_KEY_MODIFIERS;
  }

  for( keycode_index = 0; keycode_index < ( max_keycode + 1 - min_keycode ); keycode_index++ ) {
    for( wrap_key_index = 0; wrap_key_index < num_modifiers; wrap_key_index++ ) {
      str = XKeysymToString( keysyms[ keycode_index * keysyms_per_keycode + wrap_key_index ] );
      if( str != NULL ) {
        keysym = XStringToKeysym( str );
        /* keycode = XKeysymToKeycode( d, keysym ); */
        keycode = keycode_index + min_keycode;
        
          

        if( keysym < MAX_KEYSYM &&
            keysym_to_modifier_map[ keysym ] == -1 ) {
          keysym_to_modifier_map[ keysym ] = wrap_key_index;
          keysym_to_keycode_map[ keysym ] = keycode;
        }
      }
    }
  }
}

KeyCode thing_to_keycode( Display *d, const char *thing ) {
  KeyCode kc;
  KeySym ks;
  

  ks = XStringToKeysym( thing );
  if( ks == NoSymbol ){
    fprintf( stderr, "Unable to resolve keysym for '%s'\n", thing );
    return( thing_to_keycode( d, "space" ) );
  }

  kc = XKeysymToKeycode( d, ks );
  return( kc );
}

/* Simulate pressed key(s) to generate thing character
 * Only characters where the KeySym corresponds to the Unicode
 * character code and KeySym < MAX_KEYSYM are supported,
 * except the special character 'Tab'. */
void send_string( Display *d,const char *thing_in ) {
  char *wrap_key = NULL;
  int i;

  KeyCode keycode;
  KeySym keysym;

  wchar_t thing[ CMD_STRING_MAXLEN ];
  wchar_t wc_singlechar_str[2];

  wmemset( thing, L'\0', CMD_STRING_MAXLEN );
  mbstowcs( thing, thing_in, CMD_STRING_MAXLEN );
  wc_singlechar_str[ 1 ] = L'\0';
  i = 0;
  while( ( thing[ i ] != L'\0' ) && ( i < CMD_STRING_MAXLEN ) ) {
    wc_singlechar_str[ 0 ] = thing[ i ];
  
    /* keysym = wchar value */
    keysym = wc_singlechar_str[ 0 ];
    if( keysym >= MAX_KEYSYM ) {
      fprintf( stderr, "Special character '%ls' is currently not supported.\n", thing );
    }else{
      /* Keyboard modifier and KeyCode lookup */
      wrap_key = key_modifiers[ keysym_to_modifier_map[ keysym ] ];
      keycode = keysym_to_keycode_map[keysym];
	
     
      if( wrap_key != NULL )
          XTestFakeKeyEvent( d, thing_to_keycode( d, wrap_key ), True, CurrentTime );
      XTestFakeKeyEvent( d, keycode, True, CurrentTime );
      XTestFakeKeyEvent( d, keycode, False, CurrentTime );
      if( wrap_key != NULL )
          XTestFakeKeyEvent( d, thing_to_keycode( d, wrap_key ), False, CurrentTime );

      /* Not flushing after every key like we need to, thanks
       * thorsten@staerk.de */
      XFlush( d );
    }
    i++;
  }
}

void send_key( Display *d, const char *thing ) {
  XTestFakeKeyEvent( d, thing_to_keycode( d, thing ), True, CurrentTime );
  XTestFakeKeyEvent( d, thing_to_keycode( d, thing ), False, CurrentTime );
}

void mouse_click( Display *d, int button ) {
  XTestFakeButtonEvent( d, button, True, CurrentTime );
  XTestFakeButtonEvent( d, button, False, CurrentTime );
}

void mouse_move( Display *d, int x, int y ) {
  XTestFakeMotionEvent( d, -1, x, y, CurrentTime );
}

void mouse_rel_move( Display *d, int x, int y ) {
   /* This does not match my docs... hrm... */
  XTestFakeRelativeMotionEvent( d, x, y, CurrentTime );
  /* Should include screen?
  XTestFakeRelativeMotionEvent( d, -1, x, y, CurrentTime );
  */
}

void process_hotkey(Display *d,const char *cmd,int mouse_button,int hotkeynum){
	
	
	switch(hotkeynum){
		
		case Key:
			send_key(d,cmd);
			break;
		case KeyDown:
			 XTestFakeKeyEvent( d, thing_to_keycode( d, cmd), True, CurrentTime );
			break;
		case KeyUp:
			XTestFakeKeyEvent( d, thing_to_keycode( d, cmd), False, CurrentTime );
			break;
		case String:
			 send_string( d, cmd);
			 break;
		case MouseClick:
			mouse_click( d, mouse_button);
			break;
		case MouseDown:
			 XTestFakeButtonEvent( d, mouse_button, True, CurrentTime );
			 break;
		case MouseUp:
			 XTestFakeButtonEvent( d, mouse_button, False, CurrentTime );
			 break;
		default:
			break;
	}
      //usleep(20);
 XFlush( d );
}

char* getCurrAppName(Display *d) {
    Display *display= XOpenDisplay(NULL);
    Window root;
    Window parent;
    Window *child;
    Window  winfocus;
    XTextProperty prop;
    unsigned int childnum;
    int revert;
   
   XFlush(d);
   // printf("+ getCurrAppName\n");
    if (display != NULL) {
	XGetInputFocus(display,&winfocus,&revert);
	//printf("1 getCurrAppName\n");
	if ( winfocus != 0) {
	    XGetWMName(display,winfocus,&prop);
	  //  printf("2 getCurrAppName\n");
	    if ( (char*)prop.value == NULL ) {
		XQueryTree(display,winfocus,&root,&parent,&child,&childnum);
		//printf("3 getCurrAppName\n");
                if (parent != 0){
                    XGetWMName(display,parent,&prop);
		 //   printf("4 getCurrAppName\n");
		}
            }
        }
    }
    XCloseDisplay(display);
   // printf("- getCurrAppName=%s \n",(char*)prop.value);
    return ((char*)prop.value);
}

void ComboBox_1(Display *d,int fun_minor_num)
{
	
	switch(fun_minor_num){
		case	Click_Select:
					if(for_xorg_finger_flog==1)
						break;
					process_hotkey( d, NULL, 1, MouseDown);
					Button_Left_down = 1;
					break;
		case	Pop_up_Menu:
					if(for_xorg_finger_flog==1)
						break;
					process_hotkey( d, NULL, 3, MouseDown);
					Button_Right_down = 1;
					break;
		case	Middle_Button:
					if(for_xorg_finger_flog==1)
						break;
					process_hotkey( d, NULL, 2, MouseDown);
					Button_Middle_down = 1;
					break;
		case	Internet_Forward:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, RIGHT, 0, KeyDown);
					process_hotkey( d, RIGHT, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		case	Internet_Back:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, LEFT, 0, KeyDown);
					process_hotkey( d, LEFT, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
					
		case	Max_Window:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, F10, 0, KeyDown);
					process_hotkey( d, F10, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		case	Min_Window:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, F9, 0, KeyDown);
					process_hotkey( d, F9, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		case	None_Event:
					break;
		case	Page_Down:	
					process_hotkey( d, PAGE_DOWN, 0, Key);
					break;					
		case	Page_Up:		
					process_hotkey( d, PAGE_UP, 0, Key);
					break;
		case 	Scroll_Down:
					process_hotkey( d, NULL, 5, MouseClick);
					break;
		case	Scroll_Left:
					process_hotkey( d, NULL, 6, MouseClick);
					break;
		case	Scroll_Right:
					process_hotkey( d, NULL, 7, MouseClick);
					break;
		case	Scroll_Up:	
					process_hotkey( d, NULL, 4, MouseClick);
					break;
		case	Zoom_Out:
					process_hotkey( d, CONTROL_L, 0, KeyDown);
					process_hotkey( d, NULL, 5, MouseDown);
					process_hotkey( d, NULL, 5, MouseUp);
					process_hotkey( d, CONTROL_L, 0, KeyUp);
					break;
		case	Zoom_In:
					process_hotkey( d, CONTROL_L, 0, KeyDown);
					process_hotkey( d, NULL, 4, MouseDown);
					process_hotkey( d, NULL, 4, MouseUp);
					process_hotkey( d, CONTROL_L, 0, KeyUp);
					break;
		case	Close_Window:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, F4, 0, Key);					
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		case	Return_To_DeskTop:
 					string = 'D';
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, CONTROL_L, 0, KeyDown);
					process_hotkey( d, &string, 0, KeyDown);
					process_hotkey( d, &string, 0, KeyUp);
					process_hotkey( d, CONTROL_L, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		default:
					break;

	}


}


void ComboBox_2 (Display *d,int fun_minor_num)
{
	switch(fun_minor_num){		
				
		case	PAGE_Up:
					process_hotkey( d, PAGE_UP, 0, Key);
					break;
		case	PAGE_Down:
					process_hotkey( d, PAGE_DOWN, 0, Key);
					break;		
		
		case	ZOOM_Out:
					process_hotkey( d, CONTROL_L, 0, KeyDown);
					process_hotkey( d, NULL, 5, MouseDown);
					process_hotkey( d, NULL, 5, MouseUp);
					process_hotkey( d, CONTROL_L, 0, KeyUp);
					break;
		case	ZOOM_In:
					process_hotkey( d, CONTROL_L, 0, KeyDown);
					process_hotkey( d, NULL, 4, MouseDown);
					process_hotkey( d, NULL, 4, MouseUp);
					process_hotkey( d, CONTROL_L, 0, KeyUp);
					break;		
		case	MIN_Window:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, F9, 0, KeyDown);
					process_hotkey( d, F9, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		case	MAX_Window:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, F10, 0, KeyDown);
					process_hotkey( d, F10, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		default:
					break;

	}


}

void ComboBox_3 (Display *d,int fun_minor_num)
{
	switch(fun_minor_num){		
				
		case	PAGE_Up:
					process_hotkey( d, PAGE_UP, 0, Key);
					break;
		case	PAGE_Down:
					process_hotkey( d, PAGE_DOWN, 0, Key);
					break;		
		case	ROTATION_Right:
					string = 'R';
					process_hotkey( d, CONTROL_L, 0, KeyDown);
					process_hotkey( d, &string, 0, KeyDown);
					process_hotkey( d, &string, 0, KeyUp);
					process_hotkey( d, CONTROL_L, 0, KeyUp);
					break;
		case	ROTATION_Left:
					string = 'L';
					process_hotkey( d, CONTROL_L, 0, KeyDown);
					process_hotkey( d, &string, 0, KeyDown);
					process_hotkey( d, &string, 0, KeyUp);
					process_hotkey( d, CONTROL_L, 0, KeyUp);
					break;		
		case	MIN_Window:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, F9, 0, KeyDown);
					process_hotkey( d, F9, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		case	MAX_Window:
					process_hotkey( d, ALT_L, 0, KeyDown);
					process_hotkey( d, F10, 0, KeyDown);
					process_hotkey( d, F10, 0, KeyUp);
					process_hotkey( d, ALT_L, 0, KeyUp);
					break;
		default:
					break;

	}


}

void *hotkey_thread(void *arg)
{
	Display *display= XOpenDisplay(NULL);
	unsigned char *winname;
	unsigned char *cursor_theme;
	struct function_event hotkey_event[1024];
	struct timeb first_time,second_time,drag_time;
	int different_time;
	int index=0;
	int ctrl_data_index=0;
	int switch_major_num,switch_minor_num;
	int count_zoom_in=0,count_zoom_out=0;
	int xorg_tap_flag;
	char *cursor_file = NULL;
	char *cursor_mask = NULL;
	int error_sys;
	Cursor cursor;
	xorg_tap_flag=0;
	cover_gesture_release=0;
	swipe_release=0;

	winname = (unsigned char *)malloc(sizeof(unsigned char)*512);
	Button_Left_down=0;
	Button_Middle_down=0;
	Button_Right_down=0;
	setlocale(LC_ALL,  "" );
	load_keycodes(display);	
	
	auto_scroll_up_flag=0;
	auto_scroll_down_flag=0;
	auto_scroll_left_flag=0;
	auto_scroll_right_flag=0;
	auto_scroll_left_adobe_flag=0;
	auto_scroll_right_adobe_flag=0;
	ftime(&second_time);
	
#if change_cursor_image
	screen = DefaultScreen(display);
        root = RootWindow(display, screen);

	Rotation_r_image_flag=0;
	Rotation_l_image_flag=0;
	Zoom_in_image_flag=0;
	Zoom_out_image_flag=0;
	Scrool_V_image_flag=0;
	Scrool_H_image_flag=0;
#endif

	while(1)
	{	
		
#if debug_hotkey
		printf("\n ctrl_data_sem=%d\n",ctrl_data_sem);
#endif
		
		sem_wait(&ctrl_data_sem);

		can_auto_scroll_flag=0;
		
		hotkey_event[index].major_num = output_function_event[ctrl_data_index].major_num;
		hotkey_event[index].minor_num = output_function_event[ctrl_data_index].minor_num;
		hotkey_event[index].count = output_function_event[ctrl_data_index].count;
		switch_major_num = hotkey_event[index].major_num;
		switch_minor_num = hotkey_event[index].minor_num;
#if debug_hotkey
		printf("\n 2 ctrl_data_sem=%d\n",ctrl_data_sem);
#endif
			
		switch(switch_major_num){

				case Button_Left:	
				case Button_Middle:
				case Button_Right:	
				case OnefingerTapping:
				case Tapping_TwoFingers:
				case Tapping_ThreeFingers:
				case Covergusture_hand:
							switch(switch_minor_num){								   
								    case Scroll_Down:					
								    case Scroll_Left:
								    case Scroll_Right:
								    case Scroll_Up:
								    case Zoom_Out:
								    case Zoom_In:
										  winname = (unsigned char*)getCurrAppName(display);
										  break;
								    default:
										  winname = NULL;
										  break;
							}
							break;
				case Scroll_up:									
				case Scroll_down:	
				case Scroll_left:							
				case Scroll_right:
				case Zoom_out:
				case Zoom_in:
				case Rotation_right:
				case Rotation_left:
							winname = (unsigned char*)getCurrAppName(display);
							break;
				case ThreeFinger_Left:
				case ThreeFinger_Right:
				case ThreeFinger_Up:
				case ThreeFinger_Down_down:							
				case ThreeFinger_Down_left:							
				case ThreeFinger_Down_right:
				case ThreeFinger_Down_up:
							 winname = NULL;
							 break;
				default:
							break;
			  
			  }
		
		//cursor_theme = (unsigned char*)XcursorGetTheme(display);
		//printf("cursor_theme%s\n",cursor_theme);
		
		
#if debug_hotkey
		printf("3output_function_event[%d].major_num = %d \n",ctrl_data_index,output_function_event[ctrl_data_index].major_num);
		printf("3output_function_event[%d].minor_num = %d \n",ctrl_data_index,output_function_event[ctrl_data_index].minor_num);
		printf("3hotkey_event[%d].major_num = %d \n",index,hotkey_event[index].major_num);
		printf("3hotkey_event[%d].minor_num = %d \n\n",index,hotkey_event[index].minor_num);
		printf("3hotkey_event[%d].count = %d \n\n",index,hotkey_event[index].count);
		printf("winname=%s\n",winname);
#endif
		
		
		
		
		if(Button_Left_down)
		{
			process_hotkey( display, NULL, 1, MouseUp);
			Button_Left_down=0;
		}
		else if(Button_Middle_down)
		{
			process_hotkey( display, NULL, 2, MouseUp);
			Button_Middle_down=0;
		}
		else if(Button_Right_down)
		{
			process_hotkey( display, NULL, 3, MouseUp);
			Button_Right_down=0;
		}
				
		if(winname != NULL){
			#if 0
			if((strstr((char*)winname,(char *)ELAN_TOUCHPAD) != NULL)|| ((strstr((char*)winname,(char *)File_Manager) != NULL))){
				if(switch_major_num == Button_Left || switch_major_num == Button_Middle || switch_major_num == Button_Right ||
				   switch_major_num == Tapping_TwoFingers ||  switch_major_num == Tapping_ThreeFingers ||
				   switch_major_num == Covergusture_hand ){
					if(switch_minor_num == Zoom_Out)
						switch_minor_num = Zoom_In;
					else if(switch_minor_num == Zoom_In)
						switch_minor_num = Zoom_Out;
				}else if(switch_major_num == Zoom_out || switch_major_num == Zoom_in ){
					if(switch_minor_num == ZOOM_Out)
						switch_minor_num= ZOOM_In;
					else if(switch_minor_num == ZOOM_In)
						switch_minor_num= ZOOM_Out;
				}
				
				
			}
			#endif

			if(strstr((char*)winname,(char *)ACROBAT) == NULL)
			{	
				auto_scroll_left_adobe_flag=0;
				auto_scroll_right_adobe_flag=0;
			}
		}		
		for_xorg_finger_flog=0;

		
		if(ELAN_UiParamter.detect_gesture_intr==0)
		{

			switch(switch_major_num)
			{
				case Button_Left:		
							for_xorg_finger_flog=1;
							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){	
									if(switch_minor_num == Scroll_Left)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Left'");
										error_sys = system("/usr/local/bin/xte  'keyup Left'");
										
									}
									else if(switch_minor_num == Scroll_Right)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Right'");
										error_sys = system("/usr/local/bin/xte  'keyup Right'");
									}
									else if(switch_minor_num == Zoom_Out)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 5'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else if(switch_minor_num == Zoom_In)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 4'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if(strstr((char*)winname,(char *)WEB_BROWSER) != NULL){
									if(switch_minor_num == Zoom_Out)
									{
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else if(switch_minor_num == Zoom_In)
									{
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{
									if(switch_minor_num == Zoom_Out)
									{
										#if 1
										
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 5, MouseClick);
										*/
										//printf("2 Zoom out\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str -'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else if(switch_minor_num == Zoom_In)
									{
										#if 1
										
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 4, MouseClick);
										*/
										//printf("2 Zoom in\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str +'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else
									ComboBox_1(display,switch_minor_num);
									
							}else
								ComboBox_1(display,switch_minor_num);
							break;
				case Button_Middle:
							for_xorg_finger_flog=1;
							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){	
									if(switch_minor_num == Scroll_Left)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Left'");
										error_sys = system("/usr/local/bin/xte  'keyup Left'");
										
									}
									else if(switch_minor_num == Scroll_Right)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Right'");
										error_sys = system("/usr/local/bin/xte  'keyup Right'");
									}
									else if(switch_minor_num == Zoom_Out)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 5'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else if(switch_minor_num == Zoom_In)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 4'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if(strstr((char*)winname,(char *)WEB_BROWSER) != NULL){
									if(switch_minor_num == Zoom_Out)
									{
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else if(switch_minor_num == Zoom_In)
									{
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								  {	
									if(switch_minor_num == Zoom_Out)
									{
										#if 1
										
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 5, MouseClick);
										*/
										//printf("2 Zoom out\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str -'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else if(switch_minor_num == Zoom_In)
									{
										#if 1
										
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 4, MouseClick);
										*/
										//printf("2 Zoom in\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str +'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else
									ComboBox_1(display,switch_minor_num);
									
							}else
								ComboBox_1(display,switch_minor_num);
							break;
				case Button_Right:
							for_xorg_finger_flog=1;
							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){	
									if(switch_minor_num == Scroll_Left)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Left'");
										error_sys = system("/usr/local/bin/xte  'keyup Left'");
										
									}
									else if(switch_minor_num == Scroll_Right)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Right'");
										error_sys = system("/usr/local/bin/xte  'keyup Right'");
									}
									else if(switch_minor_num == Zoom_Out)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 5'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else if(switch_minor_num == Zoom_In)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 4'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if(strstr((char*)winname,(char *)WEB_BROWSER) != NULL){
									if(switch_minor_num == Zoom_Out)
									{
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else if(switch_minor_num == Zoom_In)
									{
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									if(switch_minor_num == Zoom_Out)
									{
										#if 1
										
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 5, MouseClick);
										*/
										//printf("2 Zoom out\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str -'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else if(switch_minor_num == Zoom_In)
									{
										#if 1
										
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 4, MouseClick);
										*/
										//printf("2 Zoom in\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str +'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else
									ComboBox_1(display,switch_minor_num);
									
							}else
								ComboBox_1(display,switch_minor_num);
							break;
				case OnefingerTapping:
							for_xorg_finger_flog=1;
							if(tap_timeout_release==1)
								break;
							if(xorg_tap_flag==1)
								process_hotkey( display, NULL, 1, MouseClick);
							else
								error_sys = system("elaclient TapButton1=1");	
							break;
				case Tapping_TwoFingers:
							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){	
									if(switch_minor_num == Scroll_Left)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Left'");
										error_sys = system("/usr/local/bin/xte  'keyup Left'");
										
									}
									else if(switch_minor_num == Scroll_Right)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Right'");
										error_sys = system("/usr/local/bin/xte  'keyup Right'");
									}
									else if(switch_minor_num == Zoom_Out)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 5'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else if(switch_minor_num == Zoom_In)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 4'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if(strstr((char*)winname,(char *)WEB_BROWSER) != NULL){
									if(switch_minor_num == Zoom_Out)
									{
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else if(switch_minor_num == Zoom_In)
									{
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								    {	
									if(switch_minor_num == Zoom_Out)
									{
										#if 1
										
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 5, MouseClick);
										*/
										//printf("2 Zoom out\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str -'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else if(switch_minor_num == Zoom_In)
									{
										#if 1
										
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 4, MouseClick);
										*/
										//printf("2 Zoom in\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str +'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else
									ComboBox_1(display,switch_minor_num);
									
							}else
								ComboBox_1(display,switch_minor_num);

							if(Button_Left_down)
							{
								process_hotkey( display, NULL, 1, MouseUp);
								Button_Left_down=0;
							}
							else if(Button_Middle_down)
							{
								process_hotkey( display, NULL, 2, MouseUp);
								Button_Middle_down=0;
							}
							else if(Button_Right_down)
							{
								process_hotkey( display, NULL, 3, MouseUp);
								Button_Right_down=0;
							}
							break;
				case Tapping_ThreeFingers:
							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){	
									if(switch_minor_num == Scroll_Left)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Left'");
										error_sys = system("/usr/local/bin/xte  'keyup Left'");
										
									}
									else if(switch_minor_num == Scroll_Right)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Right'");
										error_sys = system("/usr/local/bin/xte  'keyup Right'");
									}
									else if(switch_minor_num == Zoom_Out)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 5'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else if(switch_minor_num == Zoom_In)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 4'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if(strstr((char*)winname,(char *)WEB_BROWSER) != NULL){
									if(switch_minor_num == Zoom_Out)
									{
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else if(switch_minor_num == Zoom_In)
									{
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								    {	
									if(switch_minor_num == Zoom_Out)
									{
										#if 1
										
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 5, MouseClick);
										*/
										//printf("2 Zoom out\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str -'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else if(switch_minor_num == Zoom_In)
									{
										#if 1
										
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 4, MouseClick);
										*/
										//printf("2 Zoom in\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str +'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else
									ComboBox_1(display,switch_minor_num);
									
							}else
								ComboBox_1(display,switch_minor_num);
							
							if(Button_Left_down)
							{
								process_hotkey( display, NULL, 1, MouseUp);
								Button_Left_down=0;
							}
							else if(Button_Middle_down)
							{
								process_hotkey( display, NULL, 2, MouseUp);
								Button_Middle_down=0;
							}
							else if(Button_Right_down)
							{
								process_hotkey( display, NULL, 3, MouseUp);
								Button_Right_down=0;
							}
							break;
				case Scroll_up:		
							
							if((cover_gesture_release==1) || (swipe_release==1))
							{
								break;
							}
							if(winname != NULL)
								if(strstr((char*)winname,(char *)DESKTOP) != NULL)
									break;
							if(Scrool_V_image_flag==0)
							{
								#if change_cursor_image
								cursor = CreateCursorFromFiles(display,Scrool_V_image, Scrool_V_image);
								XDefineCursor(display, root, cursor);
								XFreeCursor(display, cursor);
								#else
								error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/V_Scroll.xbm /usr/share/elantouchpad_data/cursor_image/V_Scroll.xbm");
								#endif
								Rotation_r_image_flag=0;
								Rotation_l_image_flag=0;
								Zoom_in_image_flag=0;
								Zoom_out_image_flag=0;
								Scrool_V_image_flag=1;
								Scrool_H_image_flag=0;
							}
							
							if(winname != NULL){
								if(strstr((char*)winname,(char *)PHOTO_STR) != NULL)
									break;
								else if(strstr((char*)winname,(char *)PHOTO_STR1) != NULL)
								{
									process_hotkey( display, NULL, 4, MouseClick);
									break;
								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									break;
								}else
									process_hotkey( display, NULL, 4, MouseClick);
							}else
								process_hotkey( display, NULL, 4, MouseClick);

										
							auto_scroll_down_flag=0;
							auto_scroll_up_flag=1;
							can_auto_scroll_flag = 1;
							break;
				case Scroll_down:		
							if((cover_gesture_release==1) || (swipe_release==1))
							{
								break;
							}
							if(winname != NULL)
								if(strstr((char*)winname,(char *)DESKTOP) != NULL)
									break;
							if(Scrool_V_image_flag==0)
							{
								#if change_cursor_image
								cursor = CreateCursorFromFiles(display,Scrool_V_image, Scrool_V_image);
								XDefineCursor(display, root, cursor);
								XFreeCursor(display, cursor);
								#else
								error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/V_Scroll.xbm /usr/share/elantouchpad_data/cursor_image/V_Scroll.xbm");
								#endif
								Rotation_r_image_flag=0;
								Rotation_l_image_flag=0;
								Zoom_in_image_flag=0;
								Zoom_out_image_flag=0;
								Scrool_V_image_flag=1;
								Scrool_H_image_flag=0;
							}
							
							if(winname != NULL){
								if(strstr((char*)winname,(char *)PHOTO_STR) != NULL)
									break;
								else if(strstr((char*)winname,(char *)PHOTO_STR1) != NULL)
								{
									process_hotkey( display, NULL, 5, MouseClick);
									break;
								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									break;
								}else
									process_hotkey( display, NULL, 5, MouseClick);
					
								
							}else
								process_hotkey( display, NULL, 5, MouseClick);

							

							auto_scroll_up_flag=0;
							auto_scroll_down_flag= 1;
							can_auto_scroll_flag = 1;
							break;
				case Scroll_left:
							if((cover_gesture_release==1) || (swipe_release==1))
							{
								break;
							}
							if(winname != NULL)
								if(strstr((char*)winname,(char *)DESKTOP) != NULL)
									break;
							if(Scrool_H_image_flag==0)
							{
								#if change_cursor_image
								cursor = CreateCursorFromFiles(display,Scrool_H_image, Scrool_H_image);
								XDefineCursor(display, root, cursor);
								XFreeCursor(display, cursor);
								#else
								error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/H_Scroll.xbm /usr/share/elantouchpad_data/cursor_image/H_Scroll.xbm");
								#endif
								Rotation_r_image_flag=0;
								Rotation_l_image_flag=0;
								Zoom_in_image_flag=0;
								Zoom_out_image_flag=0;
								Scrool_V_image_flag=0;
								Scrool_H_image_flag=1;
							}	

							if(winname != NULL){
								if(strstr((char*)winname,(char *)PHOTO_STR) != NULL)
									break;
								else if(strstr((char*)winname,(char *)PHOTO_STR1) != NULL)
								{
									process_hotkey( display, NULL, 6, MouseClick);
									break;
								}
								else  if(strstr((char*)winname,(char *)ACROBAT) != NULL)
								{	
									auto_scroll_left_adobe_flag=1;
									auto_scroll_right_adobe_flag=0;
									error_sys = system("/usr/local/bin/xte  'key Escape'");
									error_sys = system("/usr/local/bin/xte  'keydown Left'");
									error_sys = system("/usr/local/bin/xte  'keyup Left'");
								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									break;
								}else
									process_hotkey( display, NULL, 6, MouseClick);
								
							}else
								process_hotkey( display, NULL, 6, MouseClick);
							
							

							auto_scroll_right_flag=0;
							auto_scroll_left_flag=1;						
							can_auto_scroll_flag = 1;
							break;
				case Scroll_right:
							if((cover_gesture_release==1 )|| (swipe_release==1))
							{
								break;
							}
							if(winname != NULL)
								if(strstr((char*)winname,(char *)DESKTOP) != NULL)
									break;
							if(Scrool_H_image_flag==0)
							{
								#if change_cursor_image
								cursor = CreateCursorFromFiles(display,Scrool_H_image, Scrool_H_image);
								XDefineCursor(display, root, cursor);
								XFreeCursor(display, cursor);
								#else
								error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/H_Scroll.xbm /usr/share/elantouchpad_data/cursor_image/H_Scroll.xbm");
								#endif
								Rotation_r_image_flag=0;
								Rotation_l_image_flag=0;
								Zoom_in_image_flag=0;
								Zoom_out_image_flag=0;
								Scrool_V_image_flag=0;
								Scrool_H_image_flag=1;
							}	

							if(winname != NULL){
								if(strstr((char*)winname,(char *)PHOTO_STR) != NULL)
									break;
								else if(strstr((char*)winname,(char *)PHOTO_STR1) != NULL)
								{
									process_hotkey( display, NULL, 7, MouseClick);
									break;
								}
								else  if(strstr((char*)winname,(char *)ACROBAT) != NULL)
								{	
									auto_scroll_right_adobe_flag = 1;
									auto_scroll_left_adobe_flag=0;
									error_sys = system("/usr/local/bin/xte  'key Escape'");
									error_sys = system("/usr/local/bin/xte  'keydown Right'");
									error_sys = system("/usr/local/bin/xte  'keyup Right'");
								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									break;

								}else
									process_hotkey( display, NULL, 7, MouseClick);
								
							}else
								process_hotkey( display, NULL, 7, MouseClick);


							
							auto_scroll_left_flag=0;
							auto_scroll_right_flag = 1;
							can_auto_scroll_flag = 1;
							break;
				case Zoom_out:		
							if((cover_gesture_release==1) || (swipe_release==1))
							{
								break;
							}
							if(winname != NULL)
								if(strstr((char*)winname,(char *)DESKTOP) != NULL)
									break;
							if(Zoom_out_image_flag==0)
							{
								#if change_cursor_image
								cursor = CreateCursorFromFiles(display,Zoom_out_image, Zoom_out_image);
								XDefineCursor(display, root, cursor);
								XFreeCursor(display, cursor);
								#else
								error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/Zoom_Out.xbm /usr/share/elantouchpad_data/cursor_image/Zoom_Out.xbm");
								#endif
								Rotation_r_image_flag=0;
								Rotation_l_image_flag=0;
								Zoom_in_image_flag=0;
								Zoom_out_image_flag=1;
								Scrool_V_image_flag=0;
								Scrool_H_image_flag=0;
							}
							
							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){	
									if(switch_minor_num == ZOOM_Out)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 5'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else if(switch_minor_num == ZOOM_In)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 4'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else
										ComboBox_2(display,switch_minor_num);

								}else if(strstr((char*)winname,(char *)WEB_BROWSER) != NULL){
									if(switch_minor_num == ZOOM_Out)
									{
										count_zoom_out++;
										if(count_zoom_out > COUNT_ZOOM_MAX)
										{
											ftime(&first_time);
											different_time=((first_time.time - second_time.time)*1000)+first_time.millitm-second_time.millitm;
											#if debug_fire_fox
											printf("1 count_zoom_out =%d\n",different_time);
											#endif 
											if(different_time >= WAIT_TIME){
												#if debug_fire_fox
												printf("count_zoom_out =%d\n",different_time);
												#endif
												string = '-';
												process_hotkey( display, CONTROL_L, 0, KeyDown);
												process_hotkey( display, &string, 0, String);
												process_hotkey( display, CONTROL_L, 0, KeyUp);
												ftime(&second_time);
												count_zoom_out=0;
												count_zoom_in=0;
											}
										}
									}
									else if(switch_minor_num == ZOOM_In)
									{
										count_zoom_in++;
										if(count_zoom_in > COUNT_ZOOM_MAX)
										{
											ftime(&first_time);
											different_time=((first_time.time - second_time.time)*1000)+first_time.millitm-second_time.millitm;
											#if  debug_fire_fox
											printf("2 count_zoom_in =%d\n",different_time);
											#endif
											if( different_time >= WAIT_TIME)
											{
												#if debug_fire_fox
												printf("count_zoom_in =%d\n",different_time);
												#endif
												string = '+';
												process_hotkey( display, CONTROL_L, 0, KeyDown);
												process_hotkey( display, &string, 0, String);
												process_hotkey( display, CONTROL_L, 0, KeyUp);
												ftime(&second_time);
												count_zoom_out=0;
												count_zoom_in=0;
											}
										}
									}
									else
										ComboBox_2(display,switch_minor_num);
									
								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									if(switch_minor_num == ZOOM_Out)
									{
										#if 1
										
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 5, MouseClick);
										*/
										//printf("2 Zoom out\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str -'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else if(switch_minor_num == ZOOM_In)
									{
										#if 1
										
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 4, MouseClick);
										*/
										//printf("2 Zoom in\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str +'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else
										ComboBox_2(display,switch_minor_num);

								} else
									ComboBox_2(display,switch_minor_num);
									
							}else								
								ComboBox_2(display,switch_minor_num);
							break;
				case Zoom_in:
							if((cover_gesture_release==1) || (swipe_release==1))
							{
								break;
							}
							if(winname != NULL)
								if(strstr((char*)winname,(char *)DESKTOP) != NULL)
									break;
							if(Zoom_in_image_flag==0)
							{
								#if change_cursor_image
								cursor = CreateCursorFromFiles(display,Zoom_in_image, Zoom_in_image);
								XDefineCursor(display, root, cursor);
								XFreeCursor(display, cursor);
								#else
								error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/Zoom_In.xbm /usr/share/elantouchpad_data/cursor_image/Zoom_In.xbm");
								#endif
								Rotation_r_image_flag=0;
								Rotation_l_image_flag=0;
								Zoom_in_image_flag=1;
								Zoom_out_image_flag=0;
								Scrool_V_image_flag=0;
								Scrool_H_image_flag=0;
							}
							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){	
									if(switch_minor_num == ZOOM_Out)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 5'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else if(switch_minor_num == ZOOM_In)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 4'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else
										ComboBox_2(display,switch_minor_num);
								
								}else if(strstr((char*)winname,(char *)WEB_BROWSER) != NULL){
									if(switch_minor_num == ZOOM_Out)
									{
										count_zoom_out++;
										if(count_zoom_out > COUNT_ZOOM_MAX)
										{
											ftime(&first_time);
											different_time=((first_time.time - second_time.time)*1000)+first_time.millitm-second_time.millitm;
											#if debug_fire_fox
											printf("3 count_zoom_out =%d\n",different_time);
											#endif 
											if(different_time >= WAIT_TIME){
												#if debug_fire_fox
												printf("count_zoom_out =%d\n",different_time);
												#endif
												string = '-';
												process_hotkey( display, CONTROL_L, 0, KeyDown);
												process_hotkey( display, &string, 0, String);
												process_hotkey( display, CONTROL_L, 0, KeyUp);
												ftime(&second_time);
												count_zoom_out=0;
												count_zoom_in=0;
											}
										}
									}
									else if(switch_minor_num == ZOOM_In)
									{
										count_zoom_in++;
										if(count_zoom_in > COUNT_ZOOM_MAX)
										{
											ftime(&first_time);
											different_time=((first_time.time - second_time.time)*1000)+first_time.millitm-second_time.millitm;
											#if  debug_fire_fox
											printf("4 count_zoom_in =%d\n",different_time);
											#endif
											if( different_time >= WAIT_TIME)
											{
												#if debug_fire_fox
												printf("count_zoom_in =%d\n",different_time);
												#endif
												string = '+';
												process_hotkey( display, CONTROL_L, 0, KeyDown);
												process_hotkey( display, &string, 0, String);
												process_hotkey( display, CONTROL_L, 0, KeyUp);
												ftime(&second_time);
												count_zoom_out=0;
												count_zoom_in=0;
											}
										}
									}
									else
										ComboBox_2(display,switch_minor_num);
										
								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									if(switch_minor_num == ZOOM_Out)
									{
										#if 1
										
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 5, MouseClick);
										*/
										//printf("2 Zoom out\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str -'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else if(switch_minor_num == ZOOM_In)
									{
										#if 1
										
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 4, MouseClick);
										*/
										//printf("2 Zoom in\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str +'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else
										ComboBox_2(display,switch_minor_num);

								}else
									ComboBox_2(display,switch_minor_num);
									
							}else								
								ComboBox_2(display,switch_minor_num);
							break;
				case Rotation_right:
							if(cover_gesture_release==1)
							{
								break;
							}
							if(winname != NULL)
								if(strstr((char*)winname,(char *)DESKTOP) != NULL)
									break;
							if(Rotation_r_image_flag==0)
							{
								#if change_cursor_image
								cursor = CreateCursorFromFiles(display,Rotation_right_image, Rotation_right_image);
								XDefineCursor(display, root, cursor);
								XFreeCursor(display, cursor);
								#endif
								error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/Right_Rotate.xbm /usr/share/elantouchpad_data/cursor_image/Right_Rotate.xbm");
								Rotation_r_image_flag=1;
								Rotation_l_image_flag=0;
								Zoom_in_image_flag=0;
								Zoom_out_image_flag=0;
								Scrool_V_image_flag=0;
								Scrool_H_image_flag=0;
							}
						
							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){
									if(switch_minor_num == 2){
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, SHIFT_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, SHIFT_L, 0, KeyUp);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
							  			
									}else if(switch_minor_num == 3){
										string = '_';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, SHIFT_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, SHIFT_L, 0, KeyUp);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									 
									}else
										ComboBox_3(display,switch_minor_num);
								}else if(strstr((char*)winname,(char *)PHOTO_STR1) != NULL){  	
									if(switch_minor_num == 2){
										string=']';
										process_hotkey( display, &string, 0, String);	
										
									}else if(switch_minor_num == 3){
										string='[';
										process_hotkey( display, &string, 0, String);	
									}else
										ComboBox_3(display,switch_minor_num);
								}else if(strstr((char*)winname,(char *)Open_Office) != NULL){
									if(switch_minor_num == 2 || switch_minor_num == 3)
										break;
									ComboBox_3(display,switch_minor_num);
								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									if(switch_minor_num == 2){
									#if 1
										string = 'R';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, KeyDown);
										process_hotkey( display, &string, 0, KeyUp);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										//process_hotkey( display, CONTROL_L, 0, KeyUp);
										//usleep(100);
										//printf("1 Rotation_right\n");
									#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str r'");
										error_sys = system("xte 'keyup Control_L'");
										//printf("111111111111111111111111111111111111111\n");
									#endif
									}else if(switch_minor_num == 3){
									#if 1
										string = 'R';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, SHIFT_L, 0, KeyDown);
										process_hotkey( display, &string, 0, KeyDown);
										process_hotkey( display, &string, 0, KeyUp);
										process_hotkey( display, SHIFT_L, 0, KeyUp);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										//process_hotkey( display, SHIFT_L, 0, KeyUp);
										//process_hotkey( display, CONTROL_L, 0, KeyUp);
										//usleep(100);
										//printf("1 Rotation_left\n");
									#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'keydown Shift_L'");
										error_sys = system("xte 'str r'");
										error_sys = system("xte 'keyup Shift_L'");
										error_sys = system("xte 'keyup Control_L'");
										//printf("221111111111111111111111111111111111111\n");
									#endif
									}else
										ComboBox_3(display,switch_minor_num);
								}else
									ComboBox_3(display,switch_minor_num);
							}else
								ComboBox_3(display,switch_minor_num);
							break;
				case Rotation_left:
							if(cover_gesture_release==1)
							{
								break;
							}
							if(winname != NULL)
								if(strstr((char*)winname,(char *)DESKTOP) != NULL)
									break;
							if(Rotation_l_image_flag==0)
							{
								#if change_cursor_image
								cursor = CreateCursorFromFiles(display,Rotation_left_image, Rotation_left_image);
								XDefineCursor(display, root, cursor);
								XFreeCursor(display, cursor);
								#else								
								error_sys = system("/usr/bin/xsetroot -cursor /usr/share/elantouchpad_data/cursor_image/Left_Rotate.xbm /usr/share/elantouchpad_data/cursor_image/Left_Rotate.xbm");
								#endif
								Rotation_r_image_flag=0;
								Rotation_l_image_flag=1;
								Zoom_in_image_flag=0;
								Zoom_out_image_flag=0;
								Scrool_V_image_flag=0;
								Scrool_H_image_flag=0;
							}

							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){  		
									if(switch_minor_num == 2){
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, SHIFT_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, SHIFT_L, 0, KeyUp);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
							  		}else if(switch_minor_num == 3){
									 	string = '_';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, SHIFT_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, SHIFT_L, 0, KeyUp);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}else
										ComboBox_3(display,switch_minor_num);
								}else if(strstr((char*)winname,(char *)PHOTO_STR1) != NULL){
									
									if(switch_minor_num == 2){
										string=']';	
										process_hotkey( display, &string, 0, String);	
									}else if(switch_minor_num == 3){
										string='[';
										process_hotkey( display, &string, 0, String);	
									}else
										ComboBox_3(display,switch_minor_num);
								}else if(strstr((char*)winname,(char *)Open_Office) != NULL){
									if(switch_minor_num == 2 || switch_minor_num == 3)
										break;
									ComboBox_3(display,switch_minor_num);
								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								{	
									if(switch_minor_num == 2){
									#if 1
										string = 'R';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, KeyDown);
										process_hotkey( display, &string, 0, KeyUp);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										//process_hotkey( display, CONTROL_L, 0, KeyUp);
										//usleep(100);
										//printf("2 Rotation_right\n"); 
									#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str r'");
										error_sys = system("xte 'keyup Control_L'");
										//printf("333111111111111111111111111111111111111\n");
									#endif
									}else if(switch_minor_num == 3){
									#if 1
										string = 'R';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, SHIFT_L, 0, KeyDown);
										process_hotkey( display, &string, 0, KeyDown);
										process_hotkey( display, &string, 0, KeyUp);
										process_hotkey( display, SHIFT_L, 0, KeyUp);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										//process_hotkey( display, SHIFT_L, 0, KeyUp);
										//process_hotkey( display, CONTROL_L, 0, KeyUp);
										//usleep(100);
										//printf("2 Rotation_left\n");
									#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'keydown Shift_L'");
										error_sys = system("xte 'str r'");
										error_sys = system("xte 'keyup Shift_L'");
										error_sys = system("xte 'keyup Control_L'");
										//printf("444411111111111111111111111111111111111\n");
									#endif
									}else
										ComboBox_3(display,switch_minor_num);
								}else
									ComboBox_3(display,switch_minor_num);
							}else
								ComboBox_3(display,switch_minor_num);
							
							break;
				case ThreeFinger_Left:
							if(cover_gesture_release==1)
							{
								break;
							}
	
							swipe_release=1;
							if(winname != NULL){
								if(strstr((char*)winname,(char *)PHOTO_STR) != NULL){
									process_hotkey( display, NULL, 6, MouseClick);
								}else if(strstr((char*)winname,(char *)Open_Office) != NULL){
									process_hotkey( display, CONTROL_L, 0, KeyDown);
									process_hotkey( display, PAGE_UP, 0, KeyDown);
									process_hotkey( display, PAGE_UP, 0, KeyUp);
									process_hotkey( display, CONTROL_L, 0, KeyUp);
								}else if(strstr((char*)winname,(char *)ACROBAT) != NULL){
									error_sys = system("/usr/local/bin/xte  'key Escape'");
									error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
									error_sys = system("/usr/local/bin/xte  'keydown Left'");
									error_sys = system("/usr/local/bin/xte  'keyup Left'");
									error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");;
								}
								else
								{
									process_hotkey( display, ALT_L, 0, KeyDown);
									process_hotkey( display, LEFT, 0, KeyDown);
									process_hotkey( display, LEFT, 0, KeyUp);
									process_hotkey( display, ALT_L, 0, KeyUp);
								}
								
									
							}else{
								process_hotkey( display, ALT_L, 0, KeyDown);
								process_hotkey( display, LEFT, 0, KeyDown);
								process_hotkey( display, LEFT, 0, KeyUp);
								process_hotkey( display, ALT_L, 0, KeyUp);
							}
								
							break;
				case ThreeFinger_Right:
							if(cover_gesture_release==1)
							{
								break;
							}
							swipe_release=1;	
							if(winname != NULL){
								if(strstr((char*)winname,(char *)PHOTO_STR) != NULL){
									process_hotkey( display, NULL, 7, MouseClick);
								}else if(strstr((char*)winname,(char *)Open_Office) != NULL){
									process_hotkey( display, CONTROL_L, 0, KeyDown);
									process_hotkey( display, PAGE_DOWN, 0, KeyDown);
									process_hotkey( display, PAGE_DOWN, 0, KeyUp);
									process_hotkey( display, CONTROL_L, 0, KeyUp);
									
								}else if(strstr((char*)winname,(char *)ACROBAT) != NULL){
									error_sys = system("/usr/local/bin/xte  'key Escape'");
									error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
									error_sys = system("/usr/local/bin/xte  'keydown Right'");
									error_sys = system("/usr/local/bin/xte  'keyup Right'");
									error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
							  			
								}
								else{
									process_hotkey( display, ALT_L, 0, KeyDown);
									process_hotkey( display, RIGHT, 0, KeyDown);
									process_hotkey( display, RIGHT, 0, KeyUp);
									process_hotkey( display, ALT_L, 0, KeyUp);	
								}	
							}else{
								process_hotkey( display, ALT_L, 0, KeyDown);
								process_hotkey( display, RIGHT, 0, KeyDown);
								process_hotkey( display, RIGHT, 0, KeyUp);
								process_hotkey( display, ALT_L, 0, KeyUp);
								
							}
							
							break;
				case ThreeFinger_Up:
							if(cover_gesture_release==1)
							{
								break;
							}	
						#if Linpus_driver
							error_sys = system("Thunar &");
						#else
							error_sys = system("/usr/bin/nautilus &");
						#endif
							break;
				case ThreeFinger_Down_down:
							if(cover_gesture_release==1)
							{
								break;
							}
							process_hotkey( display, ALT_L, 0, KeyDown);
							process_hotkey( display, TAB, 0, KeyDown);
							process_hotkey( display, TAB, 0, KeyUp);
							break;
				case ThreeFinger_Down_left:
							if(cover_gesture_release==1)
							{
								break;
							}	
							process_hotkey( display, SHIFT_L, 0, KeyDown);
							process_hotkey( display, TAB, 0, KeyDown);
							process_hotkey( display, TAB, 0, KeyUp);
							process_hotkey( display, SHIFT_L, 0, KeyUp);
							break;
				case ThreeFinger_Down_right:
							if(cover_gesture_release==1)
							{
								break;
							}	
							process_hotkey( display, TAB, 0, KeyDown);
							process_hotkey( display, TAB, 0, KeyUp);
							break;
				case ThreeFinger_Down_up:
							if(cover_gesture_release==1)
							{
								break;
							}
							process_hotkey( display, ALT_L, 0, KeyUp);
							break;
				case Covergusture_hand:	
							if(cover_gesture_release==1)
							{
								break;
							}
							cover_gesture_release=1;

							if(winname != NULL){
								if(strstr((char*)winname,(char *)ACROBAT) != NULL){	
									if(switch_minor_num == Scroll_Left)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Left'");
										error_sys = system("/usr/local/bin/xte  'keyup Left'");
										
									}
									else if(switch_minor_num == Scroll_Right)
									{
										error_sys = system("/usr/local/bin/xte  'key Escape'");
										error_sys = system("/usr/local/bin/xte  'keydown Right'");
										error_sys = system("/usr/local/bin/xte  'keyup Right'");
									}
									else if(switch_minor_num == Zoom_Out)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 5'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else if(switch_minor_num == Zoom_In)
									{
										error_sys = system("/usr/local/bin/xte  'keydown Control_L'");
										error_sys = system("/usr/local/bin/xte  'mouseclick 4'");
										error_sys = system("/usr/local/bin/xte  'keyup Control_L' ");
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if(strstr((char*)winname,(char *)WEB_BROWSER) != NULL){
									if(switch_minor_num == Zoom_Out)
									{
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else if(switch_minor_num == Zoom_In)
									{
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
									}
									else
										ComboBox_1(display,switch_minor_num);

								}else if((strstr((char*)winname,(char *)PHOTO_JPG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_jpg) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_BMP) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_bmp) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_PNG) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_png) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ICO) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_ico) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_GIF) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_gif) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_XBM) != NULL) ||
									 (strstr((char*)winname,(char *)PHOTO_xbm) != NULL) )
								      {	
									if(switch_minor_num == Zoom_Out)
									{
										#if 1
										
										string = '-';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 5, MouseClick);
										*/
										//printf("2 Zoom out\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str -'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
									else if(switch_minor_num == Zoom_In)
									{
										#if 1
										
										string = '+';
										process_hotkey( display, CONTROL_L, 0, KeyDown);
										process_hotkey( display, &string, 0, String);
										process_hotkey( display, CONTROL_L, 0, KeyUp);
										/*
										process_hotkey( display, NULL, 4, MouseClick);
										*/
										//printf("2 Zoom in\n");
										#else
										error_sys = system("xte 'keydown Control_L'");
										error_sys = system("xte 'str +'");
										error_sys = system("xte 'keyup Control_L'");
										#endif
									}
										ComboBox_1(display,switch_minor_num);

								}else
									ComboBox_1(display,switch_minor_num);
									
							}else
								ComboBox_1(display,switch_minor_num);							
							
							if(Button_Left_down)
							{
								process_hotkey( display, NULL, 1, MouseUp);
								Button_Left_down=0;
							}
							else if(Button_Middle_down)
							{
								process_hotkey( display, NULL, 2, MouseUp);
								Button_Middle_down=0;
							}
							else if(Button_Right_down)
							{
								process_hotkey( display, NULL, 3, MouseUp);
								Button_Right_down=0;
							}
							break;
				case DRAG_RELEASE:	
							
							xorg_tap_flag=0;							
							process_hotkey( display, NULL, 1, MouseUp);
							error_sys = system("elaclient TapButton1=1");
							break; 
				case DRAG_CLASS:		
							xorg_tap_flag=1;
							process_hotkey( display, NULL, 1, MouseDown);
							error_sys = system("elaclient TapButton1=0");
							break;
				default:
							break;
							
			
			}
		}
		else if(ELAN_UiParamter.detect_cover_intr == 0)
		{
			
			switch(switch_major_num)
			{
				case Button_Left:	
							if(switch_minor_num==Return_To_DeskTop)	
								ComboBox_1(display,switch_minor_num);
							break;
				case Button_Middle:
							if(switch_minor_num==Return_To_DeskTop)	
								ComboBox_1(display,switch_minor_num);
							break;
				case Button_Right:
							if(switch_minor_num==Return_To_DeskTop)	
								ComboBox_1(display,switch_minor_num);
							break;
				case OnefingerTapping:	
							break;
				case Tapping_TwoFingers:
							if(switch_minor_num==Return_To_DeskTop)	
								ComboBox_1(display,switch_minor_num);
							break;
				case Tapping_ThreeFingers:
							if(switch_minor_num==Return_To_DeskTop)	
								ComboBox_1(display,switch_minor_num);							
							break;
				case Scroll_up:									
				case Scroll_down:	
				case Scroll_left:							
				case Scroll_right:
				case Zoom_out:
				case Zoom_in:
				case Rotation_right:
				case Rotation_left:
				case ThreeFinger_Left:
				case ThreeFinger_Right:
				case ThreeFinger_Up:
				case ThreeFinger_Down_down:							
				case ThreeFinger_Down_left:							
				case ThreeFinger_Down_right:
				case ThreeFinger_Down_up:
							break;
				case Covergusture_hand:
							if(switch_minor_num==Return_To_DeskTop)	
								ComboBox_1(display,switch_minor_num);
							break;
				case DRAG_RELEASE:								
				case DRAG_CLASS:								
				default:
							break;
							
			
			}

		}


		if(index >= 1024)
			index = 0;
		else
			index++;

		if(ctrl_data_index >= (Max_Function_Index-1))
			ctrl_data_index = 0;
		else
			ctrl_data_index++;
		
	}

	 free(winname);	
	 XCloseDisplay(display);
	 pthread_exit(NULL);
}
